/*===========================================================================

FILE: IShellExample.c
===========================================================================*/


/*===============================================================================
INCLUDES AND VARIABLE DEFINITIONS
=============================================================================== */
#include "AEEModGen.h"          // Module interface definitions
#include "AEEAppGen.h"          // Applet interface definitions
#include "AEEShell.h"           // Shell interface definitions
#include "AEEMenu.h" 
#include "AEEStdLib.h"
// ˸    Ŭ ̵ (IShell  α׷)
#include "IShellExample.bid"
// ˸  ó  Ŭ ̵ (IShell ó α׷)
#include "IShellProcedure.bid"

#define MENU_EVENT_ALARM 401

typedef struct _CIShellExample
{
	AEEApplet		a;        //   ߰  
	IMenuCtl *		m_pIMenu;
	boolean			alarmActive;
	// Device parameters
	//int				m_nLineHeight;
	AEEDeviceInfo   m_dInfo;
} CIShellExample;

// IShellProcedure ü
typedef struct _CIShellProcedure
{
	AEEApplet	a;        //   ߰  
//	StartReason	r;
} CIShellProcedure;


/*-------------------------------------------------------------------
Function Prototypes
-------------------------------------------------------------------*/
static boolean IShellExample_HandleEvent(IApplet * pi, AEEEvent eCode, uint16 wParam, uint32 dwParam);

// IShellProcedure ø ߻ϴ ̺Ʈ ó Լ
static boolean IShellProcedure_HandleEvent(IApplet * pi, AEEEvent eCode, uint16 wParam, uint32 dwParam);

// IShellExample ø   ʱȭ Լ
static boolean IShellExample_InitAppData(IApplet* pMe);
// IShellProcedure ø   ʱȭ Լ 
static boolean IShellProcedure_InitAppData (IApplet* pMe);

// IShellExample ø    Լ
static void IShellExample_FreeAppData(IApplet* pMe);
// IShellProcedure ø    Լ
static void IShellProcedure_FreeAppData(IApplet* pMe);

AECHAR* _STR_TO_WSTR(char* pszIn, AECHAR* pDest, int nSize);
/*===============================================================================
FUNCTION DEFINITIONS
=============================================================================== */

/*===========================================================================

FUNCTION: AEEClsCreateInstance

DESCRIPTION
	This function is invoked while the app is being loaded. All Modules must provide this 
	function. Ensure to retain the same name and parameters for this function.
	In here, the module must verify the ClassID and then invoke the AEEApplet_New() function
	that has been provided in AEEAppGen.c. 

   After invoking AEEApplet_New(), this function can do app specific initialization. In this
   example, a generic structure is provided so that app developers need not change app specific
   initialization section every time except for a call to IDisplay_InitAppData(). 
   This is done as follows: InitAppData() is called to initialize AppletData 
   instance. It is app developers responsibility to fill-in app data initialization 
   code of InitAppData(). App developer is also responsible to release memory 
   allocated for data contained in AppletData -- this can be done in 
   IDisplay_FreeAppData().

PROTOTYPE:
   int AEEClsCreateInstance(AEECLSID ClsId,IShell * pIShell,IModule * po,void ** ppObj)

PARAMETERS:
	clsID: [in]: Specifies the ClassID of the applet which is being loaded

	pIShell: [in]: Contains pointer to the IShell object. 

	pIModule: pin]: Contains pointer to the IModule object to the current module to which
	this app belongs

	ppObj: [out]: On return, *ppObj must point to a valid IApplet structure. Allocation
	of memory for this structure and initializing the base data members is done by AEEApplet_New().

DEPENDENCIES
  none

RETURN VALUE
  AEE_SUCCESS: If the app needs to be loaded and if AEEApplet_New() invocation was
     successful
  EFAILED: If the app does not need to be loaded or if errors occurred in 
     AEEApplet_New(). If this function returns FALSE, the app will not be loaded.

SIDE EFFECTS
  none
===========================================================================*/
int AEEClsCreateInstance(AEECLSID ClsId,IShell * pIShell,IModule * po,void ** ppObj)
{
	*ppObj = NULL;
	// AEEApplet_New Լ ̺Ʈ ó Լ ø̼ǿ  
	//   ϴ Լ  ø ˷ִ  Ѵ.  
	// IShellExample ø Ѵ.
    if(ClsId == AEECLSID_ISHELLEXAMPLE){
		if(AEEApplet_New(sizeof(CIShellExample), ClsId, pIShell,po,(IApplet**)ppObj, (AEEHANDLER)IShellExample_HandleEvent,(PFNFREEAPPDATA)IShellExample_FreeAppData) == TRUE)
        {
			// IShellExample ø  Ʈ   ʱȭ Լ ߰
			if (IShellExample_InitAppData((IApplet*)*ppObj) == TRUE)
				return(AEE_SUCCESS);
        }
    }
    // Ʒ ڵ IShellProcedure ø Ѵ.
    if(ClsId == AEECLSID_ISHELLPROCEDURE){
		if(AEEApplet_New(sizeof(CIShellProcedure), ClsId, pIShell,po,(IApplet**)ppObj, (AEEHANDLER)IShellProcedure_HandleEvent,(PFNFREEAPPDATA)IShellProcedure_FreeAppData) == TRUE)
        {
			// Ʒ Լ IShellProcedure ø  Ʈ   ʱȭ Ѵ.
	        if (IShellProcedure_InitAppData((IApplet*)*ppObj) == TRUE)
				return(AEE_SUCCESS);
        }
	}
	return (EFAILED);
}


/*===========================================================================

FUNCTION IShellExample_HandleEvent

DESCRIPTION
	This is the EventHandler for this app. All events to this app are handled in this
	function. All APPs must supply an Event Handler.

PROTOTYPE:
	boolean IShellExample_HandleEvent(IApplet * pi, AEEEvent eCode, uint16 wParam, uint32 dwParam)

PARAMETERS:
	pi: Pointer to the AEEApplet structure. This structure contains information specific
	to this applet. It was initialized during the AEEClsCreateInstance() function.

	ecode: Specifies the Event sent to this applet

   wParam, dwParam: Event specific data.

DEPENDENCIES
  none

RETURN VALUE
  TRUE: If the app has processed the event
  FALSE: If the app did not process the event

SIDE EFFECTS
  none
===========================================================================*/
static boolean IShellExample_HandleEvent(IApplet * pi, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{  
	CIShellExample * pMe = (CIShellExample *)pi;
	AEERect rc;
   	AECHAR szBuf[50];
	AEEMenuColors mclr;
	AEEItemStyle n, s;
    SETAEERECT (&rc, 0, 0, pMe->m_dInfo.cxScreen, pMe->m_dInfo.cyScreen);
	
	switch (eCode) 
	{
	    case EVT_APP_START:
			// ˶   ޴ Ʈ Ѵ. 
			if(ISHELL_CreateInstance(pMe->a.m_pIShell, AEECLSID_MENUCTL, (void **)&pMe->m_pIMenu) != SUCCESS)
			{
				return FALSE;
			}
			
			// õ ޴  Ѵ. 
			mclr.wMask = (RGB_WHITE | RGB_BLACK | MAKE_RGB(124, 203, 247) | RGB_BLACK | RGB_WHITE);
			mclr.cBack = RGB_WHITE;
			mclr.cText = RGB_BLACK;
			//mclr.cSelBack = MAKE_RGB (146, 109, 255);
			mclr.cSelBack = MAKE_RGB (124, 109, 197);
			mclr.cSelText = RGB_BLACK;
			mclr.cFrame = RGB_WHITE;
			
			IMENUCTL_SetColors (pMe->m_pIMenu, &mclr);
			
			//ISHELL_GetItemStyle (pMe->a.m_pIShell, AEE_IT_MENU, &n, &s);
			//n.ft = AEE_FT_EMPTY;
			//n.xOffset = s.xOffset = 0;
			//n.yOffset = s.yOffset = 1;
			//s.ft = AEE_FT_EMPTY;
			//IMENUCTL_SetStyle (pMe->m_pIMenu, &n, &s);
			
			// ޴ Ʈ ŸƲ Ѵ
			
			_STR_TO_WSTR("˶ ", szBuf, sizeof(szBuf));
			IMENUCTL_SetTitle(pMe->m_pIMenu, NULL, 0, szBuf);

			IMENUCTL_SetRect(pMe->m_pIMenu, &rc);  
			// Add CreateInstance to menu
            _STR_TO_WSTR("2002 4 29  ", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVENT_ALARM, szBuf, 0);
			// Activate menu
			IMENUCTL_SetActive(pMe->m_pIMenu,TRUE);
			return(TRUE);
	    // ø   ߻ϴ ̺Ʈ̴.
	    case EVT_APP_STOP:
			return(TRUE);

	    // IShellProcedure ø EVT_ALARM ̺Ʈ   IShellProcedure 
		// ø Ǹ IShellExample Լ  · ٲ ȴ.  
		//   ̺Ʈ óϴ κ̴. 
		case EVT_APP_SUSPEND:
	    	return TRUE;
        
		// ˶  IShellProcedure ø    ¿ 
		// IShellExample Լ ٽ ȴ. ٽ   츮 ޴ ȭ鿡 
		// ѷ.
	    case EVT_APP_RESUME:
            if (pMe->m_pIMenu)
            {
				IMENUCTL_SetActive(pMe->m_pIMenu,TRUE);
				IMENUCTL_Redraw(pMe->m_pIMenu);
			}
            return TRUE;
		
		case EVT_ALARM:
			 // When an alarm is activated this applet receives this event. We need
			 // to return true here to indicate that this applet did process the Alarm
			 // event.
			return TRUE;
		// EVT_KEY ̺Ʈ ó  Ư ޴    ϴ ۾ 
		//   . ⼭ ϴ ̺Ʈ EVT_COMMAND   ȴ. 
		case EVT_KEY:
			//if (pMe->m_pIMenu)
			//{
			//	if ((IMENUCTL_IsActive(pMe->m_pIMenu) == FALSE) && ((wParam == AVK_UP) || (wParam == AVK_DOWN)))
			//	{
			//		IMENUCTL_SetActive(pMe->m_pIMenu, TRUE);
			//		IMENUCTL_Redraw(pMe->m_pIMenu);
			//	}
			return IMENUCTL_HandleEvent(pMe->m_pIMenu, EVT_KEY, wParam, 0);
			//}
			//else 
			//	return FALSE;
		// ޴    ߻ϴ ̺Ʈ̴. 츮  ̺Ʈ ó 
	    // ؼ ˶   ̴. 
		case EVT_COMMAND:
            switch(wParam)
            {
				case MENU_EVENT_ALARM:
                {
					int nRetVal = EBADPARM; // Initialize return value.
            		// ˶ ߻ϱ ð()
					uint32 numMin = 1;      
					// ˶ڵμ ٸ ˶ ϴ  Ѵ.
            		uint16 nUserCode = 4;
					
					// ȭ  Լ̴
					IDISPLAY_ClearScreen (pMe->a.m_pIDisplay);
					IMENUCTL_SetProperties(pMe->m_pIMenu, MP_NO_REDRAW);
					IMENUCTL_SetActive(pMe->m_pIMenu, FALSE);

					// 1  ˶ ̺Ʈ ߻ϰ ǰ  ̺Ʈ 
					// IShellProcedure ø ۵ȴ.
					if ((nRetVal = ISHELL_SetAlarm(pMe->a.m_pIShell, AEECLSID_ISHELLPROCEDURE, nUserCode, numMin)) == SUCCESS)
                    {
						_STR_TO_WSTR("1  ˶ ߻", szBuf, sizeof(szBuf));
						IDISPLAY_DrawText(pMe->a.m_pIDisplay, AEE_FONT_BOLD, szBuf, -1, 0, 0, 0, IDF_ALIGN_CENTER | IDF_ALIGN_MIDDLE);
						IDISPLAY_UpdateEx(pMe->a.m_pIDisplay,TRUE);
						pMe->alarmActive = TRUE;
					}
                    else
                    {
                        // ˶ 񽺰    ޽ .
						_STR_TO_WSTR("˶ ߻ ", szBuf, sizeof(szBuf));
						IDISPLAY_DrawText(pMe->a.m_pIDisplay, AEE_FONT_BOLD, szBuf, -1, 0, 0, 0, IDF_ALIGN_CENTER | IDF_ALIGN_MIDDLE);
						IDISPLAY_Update (pMe->a.m_pIDisplay); 
					}
                    return TRUE;
               }
               default:
				   return FALSE;
			}
		default:
			break;
	}
	return FALSE;
}


// IShellProcedure ̺Ʈ ó Լ IShellProcedure_HandleEvent

static boolean IShellProcedure_HandleEvent(IApplet * pi, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{  
	CIShellProcedure * pMe = (CIShellProcedure*)pi;
	AECHAR szBuf[30];

	switch (eCode) 
	{
		case EVT_APP_START:
		{
			// ˶  ޾Ҵٴ ޽ ȭ鿡 Ÿ.
			_STR_TO_WSTR(" ~~~", szBuf, sizeof(szBuf));
            IDISPLAY_DrawText(pMe->a.m_pIDisplay, AEE_FONT_BOLD, szBuf, -1, 0, 0, 0, IDF_ALIGN_CENTER | IDF_ALIGN_MIDDLE);
			IDISPLAY_Update (pMe->a.m_pIDisplay); return(TRUE);
        }
        case EVT_APP_STOP:
            return TRUE;
        // Ű   FALSE  Ѵ. FALSE  ϸ  
		// ø Ǹ鼭 ٸ ø Ѿ.  ƹ Ű  ˶ 
		// ̺Ʈ ޾ ǰ ִ IShellProcedure ø  Ǹ鼭 ˶ 
		// ̺Ʈ ߻Ű IShellExample ø ư. 
		case EVT_KEY_PRESS:
        case EVT_KEY:
	        return FALSE;
        // IShellExample ø ߻ EVT_ALARM ̺Ʈ óǴ ̴. 
		// EVT_ALARM ̺Ʈ  IShellProcedure ø   ʾ
		//   ISHELL_StartApplet Լ ȣؼ ø Ѵ. 
		case EVT_ALARM:
			ISHELL_StartApplet(pMe->a.m_pIShell,AEECLSID_ISHELLPROCEDURE);
            return TRUE;
        default:
            break;
   	}
	return FALSE;
}

// IShellExample ø   ʱȭ Լ
static boolean IShellExample_InitAppData(IApplet* pi)
{
	CIShellExample * pMe = (CIShellExample*)pi;
    // Initialize the MenuCtl pointer to NULL
    pMe->m_pIMenu = NULL;
    pMe->alarmActive = FALSE;
    ISHELL_GetDeviceInfo(pMe->a.m_pIShell,&pMe->m_dInfo);
    return TRUE;
}
// IShellProcedure ø   ʱȭ Լ 
static boolean IShellProcedure_InitAppData (IApplet* pi)
{
	CIShellProcedure * pMe = (CIShellProcedure*)pi;
	//    ߰Ǹ  Ʒ ڵ带 Էϸ ȴ.
	return TRUE;
}

// IShellExample ø    Լ
static void IShellExample_FreeAppData(IApplet* pi)
{   
	CIShellExample * pMe = (CIShellExample*)pi;
    // ޴ Ʈ   ʾҴٸ Ѵ.
    if (pMe->m_pIMenu != NULL)
    {
		// ޴ Ʈ ϴ Լ
		IMENUCTL_Release (pMe->m_pIMenu);
		pMe->m_pIMenu = NULL;
	}
	if ((pMe != NULL) && pMe->alarmActive == TRUE)
	{
		uint16 nUserCode = 4;   // User code which distinguished this alarm
                              // from another.

		// Since there is only one alarm that is activated in this example we
		// know the alarm information to deactivate it.
		ISHELL_CancelAlarm (pMe->a.m_pIShell, AEECLSID_ISHELLPROCEDURE, nUserCode);
		pMe->alarmActive = FALSE;
	}
}
// IShellProcedure ø    Լ
static void IShellProcedure_FreeAppData(IApplet* pi)
{
	    //   ߰  Լ   Ѵ.
}

AECHAR* _STR_TO_WSTR(char* pszIn, AECHAR* pDest, int nSize)
{
	char* psSource = pszIn;
	char* pcDestin = (char *)pDest;
	int npszInSize = STRLEN(pszIn);
	MEMSET(pDest, 0, nSize);
	for(psSource = pszIn; psSource < (pszIn + npszInSize); psSource++)
	{
	    if ((*psSource) < 0 || (*psSource) >= 128)
		{
		    *pcDestin = *psSource;
		    pcDestin += 1;
		} 
		else
		{
		    *pcDestin = *psSource;
		    pcDestin += 2;
		}
	}
	return (AECHAR*)pcDestin;
}
