/*===========================================================================

FILE: ishelltwo.c
===========================================================================*/


/*===============================================================================
INCLUDES AND VARIABLE DEFINITIONS
=============================================================================== */
#include "AEEModGen.h"          // Module interface definitions
#include "AEEAppGen.h"          // Applet interface definitions
#include "AEEShell.h"           // Shell interface definitions
#include "AEEMenu.h" 
#include "AEEStdLib.h"
#include "ishelltwo_res.h"
// ø̼    Ŭ ̵ (IShell  α׷)
#include "ishellapp.bid"
// ø̼    Ŭ ̵ (IShell ó α׷)
#include "ishellappsub.bid"

#define  APP_RES_FILE      "ishelltwo.bar"

#define MENU_EVT_START		401
#define MENU_EVT_SEND		402
#define MENU_EVT_POST		403
#define MENU_EVT_CLOSE		404

#define MENU_EVT_DIALOG		405
#define MENU_EVT_PROMPT		406
#define MENU_EVT_MSG		407

#define MENU_EVT_GETDEVICE		408
#define MENU_EVT_SETPREFS		409
#define MENU_EVT_GETPREFS		410
#define MENU_EVT_LOADRESDATA	411
#define MENU_EVT_LOADIMAGE		412
#define MENU_EVT_LOADRESOBJECT	413
#define MENU_EVT_IMAGE			414

#define SEND_EVENT			501
#define	POST_EVENT			502

#define SEND_EVENT_16BITDATA      0
#define POST_EVENT_16BITDATA      1
#define COMMON_32BIT_EVENT_DATA   2
// ishellapp ü. 

typedef struct _CIShellApp
{
	AEEApplet		a;        //   ߰  
	IMenuCtl *		m_pIMenu;
	AEEDeviceInfo   m_dInfo;
} CIShellApp;

typedef enum _EventType
{
	NORMAL,
	SENDEVENT,
	POSTEVENT
} EventType;

// ishellappsub ü
typedef struct _CIShellAppSub
{
	AEEApplet		a;        //   ߰  
	EventType		evt;	  // ishellapp ø  ̺Ʈ Ÿ
} CIShellAppSub;

typedef struct _ConfigData
{
   // Store the highest score from previous games
	uint16   nHighScore;
	uint16   nMyScore;
	int16    nMyMoney;
} ConfigData;


/*-------------------------------------------------------------------
Function Prototypes
-------------------------------------------------------------------*/
static boolean IShellApp_HandleEvent(IApplet * pi, AEEEvent eCode, 
                                      uint16 wParam, uint32 dwParam);

static boolean IShellAppSub_HandleEvent(IApplet * pi, AEEEvent eCode, 
                                      uint16 wParam, uint32 dwParam);


// IShellExample ø   ʱȭ Լ
static boolean IShellApp_InitAppData(IApplet* pMe);
// IShellProcedure ø   ʱȭ Լ 
static boolean IShellAppSub_InitAppData (IApplet* pMe);

// IShellApp ø    Լ
static void IShellApp_FreeAppData(IApplet* pMe);
// IShellAppSub ø    Լ
static void IShellAppSub_FreeAppData(IApplet* pMe);

AECHAR* _STR_TO_WSTR(char* pszIn, AECHAR* pDest, int nSize);

static void DisplayMessage(IApplet * pi, char *pszStr);
static void DisplayOutput(IApplet * pi, int nline, char *pszStr);

/*===============================================================================
FUNCTION DEFINITIONS
=============================================================================== */

/*===========================================================================

FUNCTION: AEEClsCreateInstance

DESCRIPTION
	This function is invoked while the app is being loaded. All Modules must provide this 
	function. Ensure to retain the same name and parameters for this function.
	In here, the module must verify the ClassID and then invoke the AEEApplet_New() function
	that has been provided in AEEAppGen.c. 

   After invoking AEEApplet_New(), this function can do app specific initialization. In this
   example, a generic structure is provided so that app developers need not change app specific
   initialization section every time except for a call to IDisplay_InitAppData(). 
   This is done as follows: InitAppData() is called to initialize AppletData 
   instance. It is app developers responsibility to fill-in app data initialization 
   code of InitAppData(). App developer is also responsible to release memory 
   allocated for data contained in AppletData -- this can be done in 
   IDisplay_FreeAppData().

PROTOTYPE:
   int AEEClsCreateInstance(AEECLSID ClsId,IShell * pIShell,IModule * po,void ** ppObj)

PARAMETERS:
	clsID: [in]: Specifies the ClassID of the applet which is being loaded

	pIShell: [in]: Contains pointer to the IShell object. 

	pIModule: pin]: Contains pointer to the IModule object to the current module to which
	this app belongs

	ppObj: [out]: On return, *ppObj must point to a valid IApplet structure. Allocation
	of memory for this structure and initializing the base data members is done by AEEApplet_New().

DEPENDENCIES
  none

RETURN VALUE
  AEE_SUCCESS: If the app needs to be loaded and if AEEApplet_New() invocation was
     successful
  EFAILED: If the app does not need to be loaded or if errors occurred in 
     AEEApplet_New(). If this function returns FALSE, the app will not be loaded.

SIDE EFFECTS
  none
===========================================================================*/
int AEEClsCreateInstance(AEECLSID ClsId,IShell * pIShell,IModule * po,void ** ppObj)
{
	*ppObj = NULL;
	// AEEApplet_New Լ ̺Ʈ ó Լ ø̼ǿ  
	//   ϴ Լ  ø ˷ִ  Ѵ.  
	// IShellApp ø Ѵ.
    if(ClsId == AEECLSID_ISHELLAPP){
		if(AEEApplet_New(sizeof(CIShellApp), ClsId, pIShell,po,(IApplet**)ppObj,
				(AEEHANDLER)IShellApp_HandleEvent,(PFNFREEAPPDATA)IShellApp_FreeAppData) == TRUE)
        {
			// IShellApp ø  Ʈ   ʱȭ Լ ߰
			if (IShellApp_InitAppData((IApplet*)*ppObj) == TRUE)
				return(AEE_SUCCESS);
        }
    }
    
	// Ʒ ڵ IShellAppSub ø Ѵ.
    if(ClsId == AEECLSID_ISHELLAPPSUB){
		if(AEEApplet_New(sizeof(CIShellAppSub), ClsId, pIShell,po,(IApplet**)ppObj,
			(AEEHANDLER)IShellAppSub_HandleEvent,(PFNFREEAPPDATA)IShellAppSub_FreeAppData) == TRUE)
        {
			// Ʒ Լ IShellAppSub ø  Ʈ   ʱȭ Ѵ.
	        if (IShellAppSub_InitAppData((IApplet*)*ppObj) == TRUE)
				return(AEE_SUCCESS);
        }
    }
	
	return (EFAILED);
}

/*===========================================================================

FUNCTION ishelltwo_HandleEvent

DESCRIPTION
	This is the EventHandler for this app. All events to this app are handled in this
	function. All APPs must supply an Event Handler.

PROTOTYPE:
	boolean ishelltwo_HandleEvent(IApplet * pi, AEEEvent eCode, uint16 wParam, uint32 dwParam)

PARAMETERS:
	pi: Pointer to the AEEApplet structure. This structure contains information specific
	to this applet. It was initialized during the AEEClsCreateInstance() function.

	ecode: Specifies the Event sent to this applet

   wParam, dwParam: Event specific data.

DEPENDENCIES
  none

RETURN VALUE
  TRUE: If the app has processed the event
  FALSE: If the app did not process the event

SIDE EFFECTS
  none
===========================================================================*/
static boolean IShellApp_HandleEvent(IApplet * pi, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{  
	CIShellApp * pMe = (CIShellApp *)pi;
	AEERect rc;
   	AECHAR szBuf[50];
	// ޴ Ʈ  Ѵ.
	AEEMenuColors mclr;
    
	SETAEERECT (&rc, 0, 0, pMe->m_dInfo.cxScreen, pMe->m_dInfo.cyScreen);
    
	
	switch (eCode) 
	{
		case EVT_APP_START:
			// ˶   ޴ Ʈ Ѵ. 
			if(ISHELL_CreateInstance(pMe->a.m_pIShell, AEECLSID_MENUCTL, (void **)&pMe->m_pIMenu) != SUCCESS){
				return FALSE;
			}

			// õ ޴  Ѵ. 
			mclr.wMask = (MC_BACK | MC_TEXT | MC_SEL_BACK | MC_SEL_TEXT | MC_FRAME);			
			mclr.cBack = RGB_WHITE;
			mclr.cText = RGB_BLACK;
			mclr.cSelBack = MAKE_RGB (146, 109, 255);

			mclr.cSelText = RGB_BLACK;
			mclr.cFrame = RGB_WHITE;

			IMENUCTL_SetColors (pMe->m_pIMenu, &mclr);
		
			// ޴ Ʈ ŸƲ Ѵ
			_STR_TO_WSTR("ISHELL ", szBuf, sizeof(szBuf));
			//STREXPAND(const byte * pSrc, int nCount, AECHAR * pDest, int nSize)
			STREXPAND("ISHELL ", sizeof("ISHELL "), szBuf, sizeof(szBuf));
			IMENUCTL_SetTitle(pMe->m_pIMenu, NULL, 0, szBuf);
			IMENUCTL_SetRect(pMe->m_pIMenu, &rc);  
			// ޴ MENU_EVENT_ALARM ̸  ߰Ѵ. 
			// ߰Ǵ  Ŭϸ MENU_EVENT_ALARM   ̺Ʈ 
			// ó  ִ. 
			STR_TO_WSTR("1. StartApplet", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_START, szBuf, 0);
			STR_TO_WSTR("2. SendEvent", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_SEND, szBuf, 0);
			STR_TO_WSTR("3. PostEvent", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_POST, szBuf, 0);
			STR_TO_WSTR("4. CloseApplet", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_CLOSE, szBuf, 0);
			_STR_TO_WSTR("5. ȭ", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_DIALOG, szBuf, 0);
			_STR_TO_WSTR("6. Ʈ", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_PROMPT, szBuf, 0);
			_STR_TO_WSTR("7. ޽ ڽ", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_MSG, szBuf, 0);
			_STR_TO_WSTR("8. ġ ", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_GETDEVICE, szBuf, 0);
			_STR_TO_WSTR("9.   ", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_SETPREFS, szBuf, 0);
			_STR_TO_WSTR("10.   б", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_GETPREFS, szBuf, 0);// Activate menu
			_STR_TO_WSTR("11. ̹ б", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_LOADRESDATA, szBuf, 0);// Activate menu
			_STR_TO_WSTR("12. ̹ б(LoadResImage)", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_LOADIMAGE, szBuf, 0);// Activate menu
			_STR_TO_WSTR("13. ̹ б(LoadResObject)", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_LOADRESOBJECT, szBuf, 0);
			_STR_TO_WSTR("14. ̹ б(LoadResObject)", szBuf, sizeof(szBuf));
			IMENUCTL_AddItem(pMe->m_pIMenu, 0, 0, MENU_EVT_IMAGE, szBuf, 0);
			IMENUCTL_SetActive(pMe->m_pIMenu,TRUE);
			return(TRUE);
	    // ø   ߻ϴ ̺Ʈ̴.	
		case EVT_APP_STOP:
			return(TRUE);
		case EVT_APP_SUSPEND:
	    	return TRUE;
	    case EVT_APP_RESUME:
			if (pMe->m_pIMenu)
            {
				IMENUCTL_SetActive(pMe->m_pIMenu,TRUE);
				IMENUCTL_Redraw(pMe->m_pIMenu);
			}
            return TRUE;
		// ȭ  ̺Ʈ
		case EVT_DIALOG_INIT:
			return TRUE;
        case EVT_DIALOG_START:
			return TRUE;
        case EVT_DIALOG_END:
			return TRUE;
		// EVT_KEY ̺Ʈ ó  Ư ޴    
		//  ۾   .. 
		case EVT_KEY:
			if (pMe->m_pIMenu)
			{
				if ((IMENUCTL_IsActive(pMe->m_pIMenu) == FALSE) && (wParam == AVK_RIGHT))
				{
					IMENUCTL_SetActive(pMe->m_pIMenu, TRUE);
					IMENUCTL_Redraw(pMe->m_pIMenu);
				}
			    return IMENUCTL_HandleEvent(pMe->m_pIMenu, EVT_KEY, wParam, 0);
			}
			else 
				return FALSE;		
		case EVT_COMMAND:
            switch(wParam)
			{
				case MENU_EVT_START:
					{
						int nRetVal = 0;
						if ((nRetVal = ISHELL_StartApplet (pMe->a.m_pIShell, AEECLSID_ISHELLAPPSUB))
							!= SUCCESS)
						{
							DisplayMessage((IApplet *)pMe, "StartApplet: ");
						}
						return TRUE;
					}
				case MENU_EVT_SEND:
					{
						int bRetVal = FALSE;
						BeepType nBeep = BEEP_ALERT;   // Beep type to play
						boolean bLoud = TRUE;          // Play loud beep
						
						bRetVal = ISHELL_SendEvent (pMe->a.m_pIShell, AEECLSID_ISHELLAPPSUB, EVT_USER, SEND_EVENT_16BITDATA, COMMON_32BIT_EVENT_DATA);
						ISHELL_Beep (pMe->a.m_pIShell, nBeep, bLoud);
						
						if (bRetVal == FALSE)
						{
							DisplayMessage ((IApplet *)pMe, "Send Event failed");
						}
						return TRUE;
					}
				case MENU_EVT_POST:
					{
						int bRetVal = FALSE;
						BeepType nBeep = BEEP_ALERT;   // Beep type to play
						boolean bLoud = TRUE;          // Play loud beep
						
						bRetVal = ISHELL_PostEvent (pMe->a.m_pIShell, AEECLSID_ISHELLAPPSUB, EVT_USER, POST_EVENT_16BITDATA, COMMON_32BIT_EVENT_DATA);
						ISHELL_Beep (pMe->a.m_pIShell, nBeep, bLoud);
						
						if (bRetVal == FALSE)
						{
							DisplayMessage ((IApplet *)pMe, "Send Event failed");
						}return TRUE;
					}
				case MENU_EVT_CLOSE:
					{
						return TRUE;
					}
				case MENU_EVT_DIALOG:
					{
						if (ISHELL_CreateDialog(pMe->a.m_pIShell, APP_RES_FILE, IDD_TEXT_DIALOG, NULL) != AEE_SUCCESS)
							return FALSE;
						else
							return TRUE;
					}
				case IDI_LIST_1:
				case IDI_LIST_2:
					{
						ISHELL_EndDialog(pMe->a.m_pIShell);
						IMENUCTL_SetActive(pMe->m_pIMenu, TRUE);
						IMENUCTL_Redraw(pMe->m_pIMenu);
						return TRUE;
					}
				case IDS_PROMPT_MENU1:
					{
						if (ISHELL_MessageBox(pMe->a.m_pIShell, APP_RES_FILE, IDS_PROMPT_TITLE, IDS_PROMPT_MENU1) == FALSE)
				          return FALSE;
						return TRUE;
					}
				case IDS_PROMPT_MENU2:
					{
						if (ISHELL_MessageBox(pMe->a.m_pIShell, APP_RES_FILE, IDS_PROMPT_TITLE, IDS_PROMPT_MENU2) == FALSE)
				          return FALSE;
						return TRUE;
					}
				case MENU_EVT_PROMPT:
					{
						AEEPromptInfo pi;
						uint16 wButtonIDs[] = {IDS_PROMPT_MENU1, IDS_PROMPT_MENU2};
						// Populate fields of the prompt info data structure
						// Name of our resource file
						pi.pszRes = APP_RES_FILE;

						// You can specify the text and title strings with character-string pointers.
						// Since we will read the text and title from the resource file, we set these
						// pointers to NULL.
						pi.pTitle = NULL;
						pi.pText = NULL;

						// Resource ID of the title for this example
						pi.wTitleID = IDS_PROMPT_TITLE;

						// We are not using the text message in this example, so set
						// this value to zero.
						pi.wTextID = 0;

						// Specify the default button (this will be the selection if the
						// prompt times out before the user has made a selection)
						pi.wDefBtn = IDS_PROMPT_MENU1;

						// Specify the button IDs, which will be presented as menu selections
						// from which the user can make a choice.
						pi.pBtnIDs = wButtonIDs;

						// The text and title are presented using a static text control (instance
						// of the IStatic interface). You can specify the control's properties here
						// (we choose to center the static text control's title).
						pi.dwProps = ST_CENTERTITLE;

						// Specify the font to be used to display the title
						pi.fntTitle = AEE_FONT_BOLD;

						// Since we're not using any text, font doesn't matter
						pi.fntText = 0;

						// Prompts have an optional timeout value--if the amount of time specified
						// passes before the user has made a selection, the selection identified
						// in the default button ID is made automatically and the prompt dialog is
						// dismissed.  Here, we set the timeout value to 0, which prevents automatic
						// selection (the prompt dialog remains on the screen until the user makes
						// a selection or exits).  See next example for a non-zero timeout value.
						pi.dwTimeout = 0;  

						// Now that the AEEPromptInfo structure has been populated, create
						// and display the prompt
						if (ISHELL_Prompt(pMe->a.m_pIShell, &pi) == FALSE)
							return TRUE;

						//IDISPLAY_UpdateEx(pMe->a.m_pIDisplay, TRUE);
						return TRUE;
					}
				case MENU_EVT_MSG:
					{
						int nBufferSize = 100 * sizeof(AECHAR);
						AECHAR szTitleBuf[20], * szTextBuf;
						_STR_TO_WSTR("޽ ڽ", szTitleBuf, sizeof(szTitleBuf));
			            if ((szTextBuf = (AECHAR *) MALLOC(nBufferSize)) == NULL)
							return FALSE;
			            _STR_TO_WSTR("MessageBoxText ׽Ʈ Դϴ.",	szTextBuf, nBufferSize);
						if (ISHELL_MessageBoxText(pMe->a.m_pIShell, szTitleBuf, szTextBuf) == FALSE)
						{
							FREE(szTextBuf);
							return FALSE;
						}
						FREE(szTextBuf);
						return TRUE;
					}
				case MENU_EVT_GETDEVICE:
					{
						char buff [30] = {0};
						IDISPLAY_ClearScreen (pMe->a.m_pIDisplay);
						IMENUCTL_SetProperties(pMe->m_pIMenu, MP_NO_REDRAW);
						IMENUCTL_SetActive(pMe->m_pIMenu, FALSE);
	
						SPRINTF (buff, "ȭ  : %u",  pMe->m_dInfo.cxScreen);
						DisplayOutput ((IApplet *)pMe, 2, buff);

						SPRINTF(buff, "ȭ  : %u", pMe->m_dInfo.cyScreen);
						DisplayOutput((IApplet *)pMe, 3, buff);

						SPRINTF(buff, "ڼ : %u", pMe->m_dInfo.wEncoding);
						DisplayOutput((IApplet *)pMe, 4, buff);

						SPRINTF(buff, "RAM  : %u", pMe->m_dInfo.dwRAM);
						DisplayOutput((IApplet *)pMe, 5, buff);
				
						SPRINTF(buff, " ÷ : %u", pMe->m_dInfo.nColorDepth);
						DisplayOutput((IApplet *)pMe, 5, buff);

						return TRUE;
					}
				case MENU_EVT_SETPREFS:
					{
						int nRetVal = 0;
						ConfigData pCfg = {0};
						pCfg.nHighScore = 444;
						pCfg.nMyMoney = 400;
						pCfg.nMyScore = 104;
	
						IDISPLAY_ClearScreen (pMe->a.m_pIDisplay);
						IMENUCTL_SetProperties(pMe->m_pIMenu, MP_NO_REDRAW);
						IMENUCTL_SetActive(pMe->m_pIMenu, FALSE);
						
						if ((nRetVal = ISHELL_SetPrefs(pMe->a.m_pIShell, AEECLSID_ISHELLAPP,
								1, &pCfg, sizeof(pCfg))) == SUCCESS)
						{
							DisplayOutput ((IApplet *)pMe, 2, "   Ǿϴ.");
						}
						return TRUE;
					}
				case MENU_EVT_GETPREFS:
					{
						ConfigData pCfg = {0};
						int nRetVal = 0;
						char szBuf [50] = {0};

						IDISPLAY_ClearScreen (pMe->a.m_pIDisplay);
						IMENUCTL_SetProperties(pMe->m_pIMenu, MP_NO_REDRAW);
						IMENUCTL_SetActive(pMe->m_pIMenu, FALSE);

						if ((nRetVal = ISHELL_GetPrefs(pMe->a.m_pIShell, AEECLSID_ISHELLAPP,
							1, &pCfg, sizeof(pCfg))) == SUCCESS)
						{
							SPRINTF (szBuf, "ְ  : %u", pCfg.nHighScore);
							DisplayOutput ((IApplet *)pMe, 2, szBuf);

							SPRINTF (szBuf, "  ڿ : %u", pCfg.nMyMoney);
							DisplayOutput ((IApplet *)pMe, 3, szBuf);
               
							SPRINTF (szBuf, "   : %u", pCfg.nMyScore);
							DisplayOutput ((IApplet *)pMe, 4, szBuf);
						}
						else
						{
							DisplayOutput ((IApplet *)pMe, 2, "No Prefs set...");
							DisplayOutput ((IApplet *)pMe, 3, "Please run SetPrefs and run GetPrefs option again");
						}
						return TRUE;
					}
				case MENU_EVT_LOADRESDATA:
					{
						            // ISHELL_LoadResData returns int instead of void *
						// 16. Usage ISHELL_LoadResData
						char szResFile[] = APP_RES_FILE;   // Resource File used by this applet
						char pszStr [50] = {0};
						// ISHELL_LoadResData: returns a void * data block associated with the
						// specified resource file, ID and type. The memory returned must be freed 
						// using the ISHELL_FreeResData call.

						AEEBmp pbmSource;
						int xDest = 4;
						int yDest = 40;
						int cxDest = pMe->m_dInfo.cxScreen;
						int cyDest = pMe->m_dInfo.cyScreen;
						int xSrc = 0;
						int ySrc = 0;
						
						AEERasterOp dwRopCode = AEE_RO_MASK;
						AEEImageInfo imageInfo;
						void *pBmp = NULL, *pDataBytes = NULL;
						boolean bVal = TRUE;

						IDISPLAY_ClearScreen (pMe->a.m_pIDisplay);
						IMENUCTL_SetProperties(pMe->m_pIMenu, MP_NO_REDRAW);
						IMENUCTL_SetActive(pMe->m_pIMenu, FALSE);

						 // Load bitmap resource from the resource file.
						pbmSource = ISHELL_LoadResData (pMe->a.m_pIShell, APP_RES_FILE, 
                                     IDB_BITMAP_LOGO, RESTYPE_IMAGE); // please do not use RESTYPE_BINARY

						//There is a header that needs to be removed before passing the data to convertbmp
						//the first byte specifies the size of the header and hence offset  we need to skip.
						pDataBytes = (byte *)pbmSource + *((byte *)pbmSource);

			            pBmp = CONVERTBMP (pDataBytes, &imageInfo, &bVal);
			            // IDISPLAY_BitBlt: performs a bit-block transfer of the data 
						// corresponding to a rectangle of pixels from the specified source 
						// bitmap into the given Display area. After calling this function, 
						// IDISPLAY_Update() must be called to update the screen. If there is 
						// a sequence of drawing operations being performed, it is sufficient 
						// to IDISPLAY_Update() once after all the drawing is done.
						IDISPLAY_BitBlt (pMe->a.m_pIDisplay, xDest, yDest, cxDest, cyDest, pBmp,
								xSrc, ySrc, dwRopCode);

						IDISPLAY_Update (pMe->a.m_pIDisplay);

			            ISHELL_FreeResData (pMe->a.m_pIShell, pbmSource);
						if(bVal)//free only if realloc was done
							SYSFREE ( pBmp);

						return TRUE;
					}
				case MENU_EVT_LOADIMAGE:
					{
						IImage *pIImage = NULL;
						char szResFile[] = APP_RES_FILE;      // Resource File used by this applet

						IDISPLAY_ClearScreen (pMe->a.m_pIDisplay);
						IMENUCTL_SetProperties(pMe->m_pIMenu, MP_NO_REDRAW);
						IMENUCTL_SetActive(pMe->m_pIMenu, FALSE);
						
						// ISHELL_LoadResObject: loads the specified resource and creates 
						// a handler that can be used on the resource Data. The type of handler
						// created is specified by the input parameter hType.

						// Load resource object of IImage type.
						pIImage = (IImage *)ISHELL_LoadResImage(pMe->a.m_pIShell, szResFile, IDB_BITMAP_LOGO);
						// Display the loaded resource object on the screen.
						IIMAGE_Draw(pIImage, 4,40);
                        
						IDISPLAY_Update (pMe->a.m_pIDisplay);
			            // Release the image object
						IIMAGE_Release (pIImage);
						return TRUE;
					}
				case MENU_EVT_LOADRESOBJECT:
					{
						 // 17. Usage ISHELL_LoadResObject
						IImage *pIImage = NULL;
						AEEHandlerType hType = HTYPE_VIEWER;  // Resource handler type (image)
						char szResFile[] = APP_RES_FILE;      // Resource File used by this applet

						IDISPLAY_ClearScreen (pMe->a.m_pIDisplay);
						IMENUCTL_SetProperties(pMe->m_pIMenu, MP_NO_REDRAW);
						IMENUCTL_SetActive(pMe->m_pIMenu, FALSE);
						// ISHELL_LoadResObject: loads the specified resource and creates 
						// a handler that can be used on the resource Data. The type of handler
						// created is specified by the input parameter hType.

						// Load resource object of IImage type.
						pIImage = (IImage *)ISHELL_LoadResObject (pMe->a.m_pIShell, szResFile, IDB_BITMAP_LOGO, hType);

						// Display the loaded resource object on the screen.
						IIMAGE_Draw(pIImage, 4,40);
						IDISPLAY_Update (pMe->a.m_pIDisplay);
						// Release the image object
						IIMAGE_Release (pIImage);
						return TRUE;
					}
				case MENU_EVT_IMAGE:
					{
						IImage * pImage = NULL;
						pImage = ISHELL_LoadImage(pMe->a.m_pIShell,"control.bmp");
						IDISPLAY_ClearScreen (pMe->a.m_pIDisplay);
						IMENUCTL_SetProperties(pMe->m_pIMenu, MP_NO_REDRAW);
						IMENUCTL_SetActive(pMe->m_pIMenu, FALSE);
						IIMAGE_Draw(pImage, 4,40);
						IDISPLAY_Update (pMe->a.m_pIDisplay);
						IIMAGE_Release(pImage);
						return TRUE;
					}
				default:
					return FALSE;
 			}
		default:
			break;
		}
	return FALSE;
}

static boolean IShellAppSub_HandleEvent(IApplet * pi, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{  
	CIShellAppSub * pMe = (CIShellAppSub*)pi;
	
	BeepType nBeep = BEEP_MSG;   
	boolean bLoud = TRUE;

	switch (eCode) 
	{
		case EVT_APP_START:
			switch(pMe->evt)
			{
			case SENDEVENT:
				DisplayMessage((IApplet *)pMe, "SendEvent ߻");
				break;
			case POSTEVENT:
				DisplayMessage((IApplet *)pMe, "PostEvent ߻");
				break;
			default:
				DisplayMessage((IApplet *)pMe, "ShellAppSub ");
				break;
			}
			return(TRUE);
		case EVT_APP_STOP:
			return TRUE;
		case EVT_USER:
			{
				switch(wParam)
				{
				case SEND_EVENT_16BITDATA:
					pMe->evt = SENDEVENT;
					ISHELL_Beep (pMe->a.m_pIShell, nBeep, bLoud);
					ISHELL_StartApplet(pMe->a.m_pIShell,AEECLSID_ISHELLAPPSUB);
					break;
				case POST_EVENT_16BITDATA:
					pMe->evt = POSTEVENT;
					ISHELL_Beep (pMe->a.m_pIShell, nBeep, bLoud);
					ISHELL_StartApplet(pMe->a.m_pIShell,AEECLSID_ISHELLAPPSUB);
				default:
					break;
				}
				return TRUE;
			}
		default:
			break;
	}
	return FALSE;
}

static boolean IShellApp_InitAppData(IApplet* pi)
{
	CIShellApp* pMe = (CIShellApp*)pi;
	// Initialize the MenuCtl pointer to NULL
	pMe->m_pIMenu = NULL;
	ISHELL_GetDeviceInfo(pMe->a.m_pIShell,&pMe->m_dInfo);
	return TRUE;
}

// IShellAppSub ø   ʱȭ Լ 
static boolean IShellAppSub_InitAppData (IApplet* pi)
{
	CIShellAppSub * pMe = (CIShellAppSub*)pi;
	//    ߰Ǹ  Ʒ ڵ带 Էϸ ȴ.
	pMe->evt = NORMAL;
	return TRUE;
}

static void IShellApp_FreeAppData(IApplet* pi)
{   
	CIShellApp* pMe = (CIShellApp*)pi;
	// ޴ Ʈ   ʾҴٸ Ѵ.
	if (pMe->m_pIMenu != NULL)
	{
		// ޴ Ʈ ϴ Լ
		IMENUCTL_Release (pMe->m_pIMenu);
		pMe->m_pIMenu = NULL;
	}
}

// IShellAppSub ø    Լ
static void IShellAppSub_FreeAppData(IApplet* pi)
{
    //   ߰  Լ   Ѵ.
}

static void DisplayMessage(IApplet * pi, char *pszStr)
{
	AECHAR szBuf[200] = {0}; 
	AEEApplet * pMe = (AEEApplet*)pi;
	_STR_TO_WSTR((char *)pszStr, szBuf, sizeof(szBuf));

	IDISPLAY_DrawText(pMe->m_pIDisplay, AEE_FONT_BOLD, szBuf, -1, 0, 0, 0, IDF_ALIGN_CENTER | IDF_ALIGN_MIDDLE);
	IDISPLAY_UpdateEx(pMe->m_pIDisplay,TRUE);
}

AECHAR* _STR_TO_WSTR(char* pszIn, AECHAR* pDest, int nSize)
{
	char* psSource = pszIn;
	char* pcDestin = (char *)pDest;
	int npszInSize = STRLEN(pszIn);
	MEMSET(pDest, 0, nSize);
	for(psSource = pszIn; psSource < (pszIn + npszInSize); psSource++)
	{
	    if ((*psSource) < 0 || (*psSource) >= 128)
		//if(! ( (*psSource) & 0x80 ) )
		//if (((*psSource) && 0x00 == TRUE) ||
		//	(*psSource) && 0x80 == FALSE)
		{
		    *pcDestin = *psSource;
		    pcDestin += 1;
		} 
		else
		{
		    *pcDestin = *psSource;
		    pcDestin += 2;
		}
	}
	return (AECHAR*)pcDestin;
}

static void DisplayOutput(IApplet * pi, int nline, char *pszStr)
{
   AEEDeviceInfo di;        // Device Info
   AECHAR szBuf[200] = {0}; // a buffer that supports 200 char string
   AECHAR * psz = NULL;
   int pixelWidth;
   AEEFont font = AEE_FONT_NORMAL;
   int pnFits = 0, dy;
   int totalCh = 0;
   int charHeight = 0;      // Stores the char height in pixels for given font
   int pnAscent = 0;        // Stores the ascent in number of pixels
   int pnDescent = 0;       // Stores the descent in number of pixels
	AEERect rc;

   AEEApplet * pMe = (AEEApplet*)pi;

   if (pMe == NULL)
      return;

   // Get device information
   ISHELL_GetDeviceInfo(pMe->m_pIShell,&di);

   // Get the font metrics info
   charHeight = IDISPLAY_GetFontMetrics (pMe->m_pIDisplay, AEE_FONT_NORMAL,
      &pnAscent, &pnDescent);

   // Convert to wide string (unicode)
   _STR_TO_WSTR ((char *)pszStr, szBuf, sizeof (szBuf));

   // If nlines is less than zero then print this string starting around the middle of 
   // the screen. Or else multiply nlines by 10 to decide the y coordinate of
   // the start of the string.
   if (nline < 0) {
      dy = di.cyScreen*2/5;
   }
   else{
      dy = nline * charHeight;
   }

   // psz keeps track of the point from which to write from the string buffer
   // in case the string does not fit one line and needs to wrap around in the
   // next line.
   psz = szBuf;
      
   // Need to calculate the lotal string length to decide if any wrapping
   // around is needed.
   totalCh = STRLEN ((char *)pszStr);

   // Keep displaying text string on multiple lines if the string can't be displayed
   // on one single line. Lines are spaced 15 pixels apart.
   while ((totalCh > 0) && (*psz != NULL))
   { 
      // Get information on how many characters will fit in a line.
      // Give the pointer to the buffer to be displayed, and the number of
      // pixels along the x axis you want to display the string in (max number)
      // pnFits will have the max number of chars that will fit in the maxWidth
      // number of pixels (given string can't fit in one line), or the number of 
      // chars in the string (if it does fit in one line). pnWidth gives the
      // number of pixels that will be used to display pnFits number of chars.
      pixelWidth = IDISPLAY_MeasureTextEx(pMe->m_pIDisplay,
                      font, 
                      (AECHAR *) psz,  // Start of the buffer to display,
                      -1,
                      di.cxScreen - 5, // maxWidth
                      &pnFits);         // Number of chars that will fit a line

      // If pnFits is zero there is something wrong in the input to above function. 
      // Normally this scenario should not occur. But, have the check anyway.
      if (pnFits == 0)
         return;

		SETAEERECT(&rc, 0, dy, di.cxScreen, charHeight);
		IDISPLAY_EraseRect(pMe->m_pIDisplay, &rc);
      IDISPLAY_DrawText(pMe->m_pIDisplay, AEE_FONT_NORMAL, psz, pnFits, 5 /*start dx*/, 
         dy, 0 /* use default rectangle coordinates */, 0);

      psz += pnFits;      // move pointer to the next segment to be displayed
      totalCh -= pnFits;  // reduce the total number of characters to still display
      dy += charHeight;   // Place next line charHeight pixels below the 
                          // previous line. 
      IDISPLAY_Update(pMe->m_pIDisplay);
      if (totalCh < pnFits)
         pnFits = totalCh;  // if total number is less than pnFits, adjust pnFits
   }
   return;   
} // End of DisplayOutput
